/**
  *  \file client/dlg-structure.h
  *
  *  (c) 2001-2005 Stefan Reuther <Streu@gmx.de>
  *
  *  This program is free software; you can redistribute it and/or
  *  modify it under the terms of file `COPYING' that comes with the
  *  source code.
  *
  *  This program is distributed in the hope that it will be useful,
  *  but WITHOUT ANY WARRANTY; without even the implied warranty of
  *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
  */
#ifndef PCC_V2_CLIENT_DLG_STRUCTURE_H
#define PCC_V2_CLIENT_DLG_STRUCTURE_H

#include "ui/widgets.h"
#include "client/actions.h"
#include "game/planet.h"

class GPlanetBuildStructuresAction;
class GPlanet;
class GUniverse;

class WPlanetStructureWidget : public UIWidget {
    GPlanetBuildStructuresAction&  action;
    TPlanetaryStructure            structure;
    SignalConnection               conn;
 public:
    WPlanetStructureWidget(GPlanetBuildStructuresAction& action,
                           TPlanetaryStructure structure);
    ~WPlanetStructureWidget();
    void add(int arg);
    void remove(int arg);

    void draw(GfxCanvas& can, UpdateInfo& ui);
    bool handleEvent(const UIEvent& e, bool second_pass);
    void getLayoutInfo(LayoutInfo& info);
};

class WPlanetStructureGroup : public UIFocusGroup {
    WPlanetStructureWidget psw;
    UIButton add_btn, sub_btn;
    TPlanetaryStructure structure;
 public:
    WPlanetStructureGroup(int id,
                          GPlanetBuildStructuresAction& action,
                          TPlanetaryStructure structure);
    ~WPlanetStructureGroup();
    void getLayoutInfo(LayoutInfo& info);
    void setExtent(GfxRect newpos, bool by_layout);
    void drawInterior(GfxCanvas& can, UpdateInfo& ui);
};

void doPlanetBuildScreen(GUniverse& univ, GPlanet& planet, int start_screen);

#endif
