/**
  *  \file io/memstream.h
  *
  *  (c) 2001-2005 Stefan Reuther <Streu@gmx.de>
  *
  *  This program is free software; you can redistribute it and/or
  *  modify it under the terms of file `COPYING' that comes with the
  *  source code.
  *
  *  This program is distributed in the hope that it will be useful,
  *  but WITHOUT ANY WARRANTY; without even the implied warranty of
  *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
  */
#ifndef PCC_V2_IO_MEMSTREAM_H
#define PCC_V2_IO_MEMSTREAM_H

#include "io/streams.h"
#include "cpluslib/buffer.h"

class MemoryStream : public Stream {
    Buffer<char>  data;
    std::size_t   pos;
 public:
    MemoryStream();
    MemoryStream(const string_t& s);
    MemoryStream(const Buffer<char>& buf);
    ~MemoryStream();

    const Buffer<char>&  getBuffer() const { return data; }
    void                 swapBuffer(Buffer<char>&);
    string_t             getContentsAsString() const;

    std::size_t  read(char* buffer, std::size_t max);
    std::size_t  write(const char* buffer, std::size_t max);
    int          getCapabilities() const;
    bool         seek(fpos_t pos);
    fpos_t       getSize();
    fpos_t       getPos();
    string_t     getName();
};

#endif
